# AUTOGENERATED! DO NOT EDIT! File to edit: ../nbs/02_cons.ipynb.

# %% auto 0
__all__ = ['ARGS_KIND', 'KWDS_KIND']

# %% ../nbs/02_cons.ipynb 6
from inspect import (Parameter, _ParameterKind as ParamKind)

# %% ../nbs/02_cons.ipynb 8
#| export


# %% ../nbs/02_cons.ipynb 10
#| export


# %% ../nbs/02_cons.ipynb 12
#| export


# %% ../nbs/02_cons.ipynb 14
from .type import BoundSignatureOptions, P

# %% ../nbs/02_cons.ipynb 16
ARGS_KIND = (ParamKind.POSITIONAL_ONLY, ParamKind.POSITIONAL_OR_KEYWORD)
'''tuple of `ParameterKind` that are positional arguments, but not `*args`.''';

KWDS_KIND = (ParamKind.KEYWORD_ONLY, ParamKind.POSITIONAL_OR_KEYWORD)
'''tuple of `ParameterKind` that are keyword arguments, but not `**kwargs`.''';

# %% ../nbs/02_cons.ipynb 17
_ARGS = Parameter('args', kind=ParamKind.VAR_POSITIONAL, annotation=P.args)
'''Default `Parameter` for `*args`.''';

_KWDS = Parameter('kwargs', kind=ParamKind.VAR_KEYWORD, annotation=P.kwargs)
'''Default `Parameter` for `**kwargs`.''';

# %% ../nbs/02_cons.ipynb 18
_BSO: BoundSignatureOptions | None = BoundSignatureOptions()
'''Default optional (i.e. empty) `BoundSignatureOptions` instance.''';

_BSO_DEFAULTS: BoundSignatureOptions = BoundSignatureOptions(__args=True, __kwds=True, __zero_idx=False)
'''Default `BoundSignatureOptions` instance with some options preset.''';

# %% ../nbs/02_cons.ipynb 19
U1 = '_'
U2 = '__'
NIL = ''

DCT = 'dct'
NON = 'non'
OPT = 'opt'
SIG = 'sig'
RETURN = 'return'
SUBCLASS = 'subclass'

ARGS = 'args'
KWARGS = 'kwargs'

__DOC__ = '__doc__'
__NEW__ = '__new__'
__NAME__ = '__name__'
__MODULE__ = '__module__'

# ducktype
__SPECIES__ = '__species__'
__USETYPES__ = '__usetypes__'
__DUCKTYPE__ = '__ducktype__'

# type-dict 
__DEFAULTS__ = '__defaults__'
__TYPEDICT__ = '__typedict__'

# wrapper
__QUALNAME__ = '__qualname__'
__SIGNATURE__ = '__signature__'
__ANNOTATIONS__ = '__annotations__'

# %% ../nbs/02_cons.ipynb 21
_extra_args = (('__earg', 'earg', 'extra_args', 'varg', ), (), '__earg')
_extra_kwds = (('__ekws', 'ekws', 'extra_kwds', 'vkws', ), {}, '__ekws')
_outer_args = (('__oarg', 'oarg', 'outer_args', 'darg', ), (), '__oarg')
_outer_kwds = (('__okws', 'okws', 'outer_kwds', 'dkws', ), {}, '__okws')
_bind_opts = (('__bind_kwds', ), {})
